// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------
#ifndef __VCtlHelp_H__
#define __VCtlHelp_H__

#ifdef VF_STATIC
	#undef AFX_EXT_CLASS
	#define AFX_EXT_CLASS
#endif

#define VHELPER_ID			300
#define VHELPER_ADDFORTMPID	50
#define VHELPER_EDIT		0
#define VHELPER_MASK		1
#define VHELPER_COMBO		2
#define VHELPER_TCKEDIT		3

// -------------------------------------------------------------------------
//	VCtlHelper is used to wrap a helper control which is then used by a VCtl
//  to perform its job.
//
//  This class is needed to ensure appropriate destructors for helper windows
//  get called.
// -------------------------------------------------------------------------
class AFX_EXT_CLASS VCtlHelper
{
protected:

public:
	VCtlHelper() {};
	virtual ~VCtlHelper() {};

	virtual int Id()=0;					// Returns helper Id (index)
	virtual void Hide()=0;				// Hide the helper control
	virtual void Show(CRect rect)=0;	// Show the helper control
	virtual CWnd* GetCWnd()=0;			// Return the controls CWnd pointer
};

// -------------------------------------------------------------------------
//  VSmallEdit helper control.
// -------------------------------------------------------------------------
class AFX_EXT_CLASS VSmallEditHelper : public VCtlHelper
{
protected:
	CEdit	m_ctlEdit;				// Helper CEdit class

public:
	VSmallEditHelper(CWnd *pParent);
	virtual ~VSmallEditHelper() {};

	virtual	int  Id()		{ return VHELPER_EDIT; }	// Helper Id (index)
	static  int  HelperId()	{ return VHELPER_EDIT; }	// Helper Id (index)
	int		GetControlId()	{ return VHELPER_ID + VHELPER_EDIT; }	// Control ID
	virtual void Hide();
	virtual void Show(CRect rect);
	CEdit*	GetControl()	{ return &m_ctlEdit; }		// The actual control
	CWnd*	GetCWnd()		{ return &m_ctlEdit; }		// The control
};

#endif
